/*
 * Copyright (c) 2005-2013, BearWare.dk
 * 
 * Contact Information:
 *
 * Bjoern D. Rasmussen
 * Bedelundvej 79
 * DK-9830 Taars
 * Denmark
 * Email: contact@bearware.dk
 * Phone: +45 20 20 54 59
 * Web: http://www.bearware.dk
 *
 * This source code is part of the TeamTalk 4 SDK owned by
 * BearWare.dk. All copyright statements may not be removed 
 * or altered from any source distribution. If you use this
 * software in a product, an acknowledgment in the product 
 * documentation is required.
 *
 */

#include "connectdlg.h"
#include "mainwindow.h"

extern QSettings* ttSettings;

ConnectDlg::ConnectDlg(QWidget * parent/* = 0*/)
    : QDialog(parent, Qt::Dialog | Qt::WindowTitleHint)
{
    ui.setupUi(this);
    setWindowIcon(QIcon(APPICON));

    ui.tcpportEdit->setText(QString::number(DEFAULT_TCPPORT));
    ui.udpportEdit->setText(QString::number(DEFAULT_UDPPORT));

    HostEntry host;
    int index = 0;
    while(GetLatestHost(index++, host))
        ui.hostaddrBox->addItem(host.ipaddr);
    slotShowHost(0);

    connect(ui.buttonBox, SIGNAL(accepted()), SLOT(slotSaveChanges()));
    connect(ui.accountChkBox, SIGNAL(clicked(bool)), 
            SLOT(slotAccountLogin(bool)));
    connect(ui.hostaddrBox, SIGNAL(currentIndexChanged(int)),
            SLOT(slotShowHost(int)));
}

void ConnectDlg::slotSaveChanges()
{
    HostEntry host;
    host.ipaddr = ui.hostaddrBox->currentText();
    host.tcpport = ui.tcpportEdit->text().toInt();
    host.udpport = ui.udpportEdit->text().toInt();
    host.srvpasswd = ui.srvpasswdEdit->text();
    host.username = ui.usernameEdit->text();
    host.password = ui.passwordEdit->text();
    host.channel = ui.channelEdit->text();
    host.chanpasswd = ui.chanpasswdEdit->text();
    AddLatestHost(host);
}

void ConnectDlg::slotShowHost(int index)
{
    HostEntry host;
    if(GetLatestHost(index, host))
    {
        slotAccountLogin((bool)host.username.size());
        ui.hostaddrBox->setCurrentIndex(index);
        ui.tcpportEdit->setText(QString::number(host.tcpport));
        ui.udpportEdit->setText(QString::number(host.udpport));
        ui.srvpasswdEdit->setText(host.srvpasswd);
        ui.usernameEdit->setText(host.username);
        ui.passwordEdit->setText(host.password);
        ui.channelEdit->setText(host.channel);
        ui.chanpasswdEdit->setText(host.chanpasswd);
    }
}

void ConnectDlg::slotAccountLogin(bool checked)
{
    ui.stackedWidget->setCurrentIndex(checked?1:0);
}
